'From Jasmine-rc1 of 7 October 2004 [latest update: #171] on 29 November 2004 at 8:14:45 pm'!
"Change Set:		VRMLCroquetImporter
Date:			28 November 2004
Author:			Dave Faught

This is a non-functional version of a VRML importer for Croquet.  It was largely copied directly from the VRMLWonderlandBuilder.  Along the way, many methods that didnt seem to be needed were dropped, and anything referring to an actor was renamed to a frame.  The VRMLCroquetBuilder>>doConvert: method was copied from a posting by Andreas Raab to convert from B3DIndexedMesh to TMesh.  Currently this importer locks up in a CPU loop that cannot be broken out of.  I am thinking that this is because the objects that are being rendered are not defined properly, and because of that the TeaTestVRML #render and #drawOn: methods are nil'ed out to allow some debugging to take place. If you can figure out whats wrong here, please let me know."!

TeapotMorph subclass: #TeaTestVRML
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Import-VRML'!
VRMLEnumerator subclass: #VRMLCroquetBuilder
	instanceVariableNames: 'myTSpace scene attributes baseFrame currentFrame progress defaultCamera defaultMaterial '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Import-VRML'!

!TeaTestVRML methodsFor: 'initialization' stamp: 'daf 11/29/2004 19:23'!
initializeDefaultSpace
	| space |

	space _ TSpace new.
	space url: 'http://www.reed.com/TeaLand/spaces/intro.tea'.

	"Add a light to the world "
	self makeLight: space.

	" Add a few fun objects. "
	self makeFloor: space fileName:'stone.BMP'.

	self makePopUp: space.

	self makeFrame: space fromVRML: 'c:\download\blender\STAGE.wrl'.

	^space! !

!TeaTestVRML methodsFor: 'converting' stamp: 'daf 11/29/2004 18:47'!
makeBaseFrameFrom: filename
	| baseFrame |
	"Base frame creation"
	baseFrame _ TFrame new initialize.
	^baseFrame! !

!TeaTestVRML methodsFor: 'converting' stamp: 'daf 11/29/2004 19:29'!
makeFrame: space fromVRML: filename
	"Creates a new frame using the specification from the given file"
	| baseFrame parserClass builderClass scene |

	parserClass _ Smalltalk at: #VRMLNodeParser ifAbsent:[
		self reportErrorToUser:'No VRML parser found'.
		^self].
	builderClass _ Smalltalk at: #VRMLCroquetBuilder ifAbsent:[
		self reportErrorToUser:'No VRML to Croquet converter found'.
		^self].
	baseFrame _ self makeBaseFrameFrom: filename.
	space addChild: baseFrame.
	parserClass == nil
		ifFalse:[scene _ parserClass parseFileNamed: filename].

"scene inspect."

	(builderClass == nil or:[scene == nil])
		ifFalse:[(builderClass on: scene) 
					baseFrame: baseFrame;
					buildFramesFor: space].
	scene _ nil.

baseFrame inspect.

	"Ensure that the new frame's name is unique"
"	myNamespace at: baseFrame getName put: baseFrame.
	scriptEditor updateSpaceBrowser. "

	^ baseFrame.
! !

!TeaTestVRML methodsFor: 'as yet unclassified' stamp: 'daf 11/29/2004 20:02'!
drawOn: aCanvas
	^ nil! !

!TeaTestVRML methodsFor: 'as yet unclassified' stamp: 'daf 11/29/2004 20:02'!
render
	^ nil! !


!TeaTestVRML class methodsFor: 'as yet unclassified' stamp: 'daf 11/27/2004 10:26'!
descriptionForPartsBin
	^ self partName:	(self name)
		categories:		#('Croquet')
		documentation:	'Croquet Browser'
		sampleImageForm: TForm defaultForm.
! !

!TeaTestVRML class methodsFor: 'as yet unclassified' stamp: 'daf 11/27/2004 10:26'!
includeInNewMorphMenu

	^true! !


!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:05'!
baseFrame
	^baseFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:06'!
baseFrame: aTFrame
	baseFrame _ aTFrame.
	self currentFrame: baseFrame.! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/28/2004 21:19'!
buildFrames
	"Using the given VRML scene build a set of frames for TSpace"
	attributes _ Dictionary new.

	Utilities informUserDuring:[:bar| 
		progress _ bar.
		scene doWith: self].! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:09'!
buildFramesFor: aTSpace
	"Using the given VRML scene build a set of frames for TSpace"
	self initializeFor: aTSpace.
	self buildFrames.! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:12'!
createFrameFor: aMesh
	^self createFrameFor: aMesh suffix:''! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:15'!
createFrameFor: aMesh defaultName: aString
	^self createFrameFor: aMesh
			name: (attributes at: #currentName ifAbsent:[aString])
			suffix: ''! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/29/2004 19:56'!
createFrameFor: aMesh name: aString suffix: suffix
	| frame |
	frame _ self createSimpleFrame: aMesh 
					named: aString, suffix
					parent: currentFrame.
	"frame material: (attributes at: #currentMaterial ifAbsent:[nil])."
	aMesh == nil ifFalse:[attributes at: #currentShape put: frame].
	^frame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:21'!
createFrameFor: aMesh suffix: aString
	^self createFrameFor: aMesh
			name: (attributes at: #currentName ifAbsent:['unnamed'])
			suffix: aString! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 23:17'!
createSimpleFrame: aMesh named: aString parent: parentFrame
	| newFrame |
	newFrame _ self makeFrameNamed: aString.
	aMesh ifNotNil:[newFrame addChild: (self doConvert: aMesh)].
	parentFrame ifNotNil:[
		newFrame parent: parentFrame.
		parentFrame addChild: newFrame].
	^newFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:11'!
currentFrame
	^currentFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/27/2004 10:11'!
currentFrame: aTFrame
	currentFrame _ aTFrame! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/29/2004 19:58'!
doConvert: myMesh
	"convert from B3DIndexedMesh to TMesh"
	| mesh |
	mesh := TMesh new
        initializeWithVertices: myMesh vertices
        alias: nil
        norms: myMesh vertexNormals
        textureUV: myMesh texCoords
        faceGroups: {1. myMesh zeroBasedFaceGroup}
        material: nil.
	mesh material: (attributes at: #currentMaterial ifAbsent:[defaultMaterial]).
	mesh initBounds.
	^ mesh
! !

!VRMLCroquetBuilder methodsFor: 'building frames' stamp: 'daf 11/28/2004 21:13'!
makeFrameNamed: name
	"create a frame"

	| frame |
	frame _ TFrame new.
	myTSpace addChild: frame.
	^ frame! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:27'!
assignIndexedColors: node in: mesh
	| attr colors colorIndex faces vertices |
	attributes at: #currentColors put: nil.
	(attr _ node attributeValueNamed: 'color') notNil
		ifTrue:[attr doWith: self].
	colors _ attributes at: #currentColors.
	(colors == nil or:[colors size = 0]) ifTrue:[^self].
	attr _ (node attributeValueNamed: 'colorIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed:'coordIndex')].
	colorIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[colorIndex next = -1] whileTrue.
		colorIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) color: (colors at: colorIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:27'!
assignIndexedNormals: node in: mesh
	| attr normals nrmlIndex faces vertices |
	attributes at: #currentNormals put: nil.
	(attr _ node attributeValueNamed: 'normal') notNil
		ifTrue:[attr doWith: self].
	normals _ attributes at: #currentNormals.
	normals == nil ifTrue:[^self].
	attr _ (node attributeValueNamed: 'normalIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed: 'coordIndex')].
	nrmlIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[nrmlIndex next = -1] whileTrue.
		nrmlIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) normal: (normals at: nrmlIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:28'!
assignIndexedTexCoords: node in: mesh
	| attr faces vertices texCoords texIndex |
	attributes at: #currentTexCoords put: nil.
	(attr _ node attributeValueNamed: 'texCoord') notNil
		ifTrue:[attr doWith: self].
	texCoords _ attributes at: #currentTexCoords.
	texCoords == nil ifTrue:[^self].
	attr _ (node attributeValueNamed: 'texCoordIndex').
	attr size = 0 ifTrue:[attr _ (node attributeValueNamed:'coordIndex')].
	texIndex _ ReadStream on: attr.
	faces _ mesh faces.
	1 to: faces size do:[:i|
		vertices _ (faces at: i) vertices.
		[texIndex next = -1] whileTrue.
		texIndex skip: -1.
		1 to: vertices size do:[:index|
			(vertices at: index) texCoord: (texCoords at: texIndex next + 1).
		].
	].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doAppearance: node
	| attr |
	(attr _ node attributeValueNamed: 'material') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'texture') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'textureTransform') notNil
		ifTrue:[attr doWith: self].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:13'!
doBox: node
	| size box |
	size _ (node attributeValueNamed:'size').
	box _ B3DIndexedMesh vrml97Box.
	self createFrameFor: box defaultName:'box'.
	currentFrame resizeRightNow: size first @ size second @ size third undoable: false.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doColor: node
	| colors |
	colors _ (node attributeValueNamed: 'color').
	attributes at: #currentColors put: (colors collect:[:c| c asB3DColor])! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:14'!
doCone: node
	| radius height doSide doBottom cone |
	radius _ (node attributeValueNamed:'bottomRadius').
	height _ (node attributeValueNamed:'height').
	doSide _ (node attributeValueNamed:'side').
	doBottom _ (node attributeValueNamed:'bottom').
	cone _ B3DIndexedMesh vrml97Cone: doSide bottom: doBottom.
	self createFrameFor: cone defaultName:'cone'.
	currentFrame resizeRightNow: radius @ height @ radius undoable: false.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:23'!
doCoordinate: node
	| attr points interpolator |
	(attr _ node attributeValueNamed: 'point') notNil ifTrue:[
		points _ self mfVec3fFrom: attr.
		(scene targetNodes includes: node) ifTrue:[
			interpolator _ nil.
			scene sourceNodes do:[:n|
				n actionsDo:[:set|
					set do:[:msg| msg receiver == node ifTrue:[interpolator _ n]]]].
			interpolator _ self mfVec3fFromInterpolator: interpolator.
		].
	].
	points == nil
		ifTrue:[attributes removeKey: #currentPoints]
		ifFalse:[attributes at: #currentPoints put: points].
	interpolator == nil
		ifTrue:[attributes removeKey: #interpolatorPoints ifAbsent:[]]
		ifFalse:[attributes at: #interpolatorPoints put: interpolator].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:14'!
doCylinder: node
	| radius height doSide doBottom doTop cylinder |
	radius _ (node attributeValueNamed:'radius').
	height _ (node attributeValueNamed:'height').
	doSide _ (node attributeValueNamed:'side').
	doBottom _ (node attributeValueNamed:'bottom').
	doTop _ (node attributeValueNamed:'top').
	cylinder _ B3DIndexedMesh vrml97Cylinder: doSide bottom: doBottom top: doTop.
	self createFrameFor: cylinder defaultName:'cylinder'.
	currentFrame resizeRightNow: radius @ height @ radius undoable: false.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 11:38'!
doDirectionalLight: node
	| ambientIntensity intensity color on light dir |
	ambientIntensity _ (node attributeValueNamed:'ambientIntensity').
	intensity _ (node attributeValueNamed: 'intensity').
	color _ (node attributeValueNamed: 'color').
	dir _ self positionFrom: (node attributeValueNamed:'direction').
	on _ (node attributeValueNamed:'on').
	light _ TLight new type: #directional.
	light ambientColor: (color * ambientIntensity).
	light diffuseColor: (color * intensity).
	light spotDirection: dir.
	currentFrame ifNotNil:[light reparentTo: currentFrame].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 11:41'!
doImageTexture: node
	| attr texFileName tex |
	"Create a new texture."
	(attr _ node attributeValueNamed: 'url') notNil
		ifTrue:[
			texFileName _ (FileDirectory on: (FileDirectory dirPathFor: scene fileURL)) fullNameFor: attr first.
			(FileDirectory default fileExists: texFileName)
				ifTrue:[tex _ TTexture new initializeWithFileName: texFileName].
			attributes at: #currentTexture put: tex].
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 19:43'!
doIndexedFaceSet: node
	| attr faces points mesh ipPoints meshList map |
	attributes at: #currentPoints put: nil.
	(attr _ node attributeValueNamed: 'coord') notNil
		ifTrue:[attr doWith: self].
	points _ attributes at: #currentPoints.
	ipPoints _ attributes at: #interpolatorPoints ifAbsent:[nil].
	points ifNil:[^self].
	(attr _ node attributeValueNamed: 'coordIndex') notNil
		ifTrue:[faces _ self facesFrom: attr for: points].
	faces ifNil:[^self].
	mesh _ B3DSimpleMesh withAll: faces.
	self assignIndexedNormals: node in: mesh.
	self assignIndexedTexCoords: node in: mesh.
	self assignIndexedColors: node in: mesh.
	mesh _ mesh asIndexedTriangleMesh.
	ipPoints == nil ifFalse:[
		"Re-map points for interpolated meshes"
		map _ Dictionary new: points size * 2.
		points doWithIndex:[:pt :index| map at: pt put: index].
		meshList _ ipPoints collect:[:pts|
			mesh clone vertices: (mesh vertices collect:[:pt| pts at: (map at: pt)])].
		mesh _ B3DInterpolatedMesh new initialize meshes: meshList.
	].
	self createFrameFor: mesh.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doLOD: node
	| levels |
	levels _ (node attributeValueNamed: 'level').
	levels size > 0 ifTrue:[
		levels last doWith: self.
	].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 11:44'!
doMaterial: node
	| ambientIntensity diffuseColor emissiveColor shininess specularColor material transparency |
	ambientIntensity _ (node attributeValueNamed: 'ambientIntensity').
	diffuseColor _ (node attributeValueNamed: 'diffuseColor').
	emissiveColor _ (node attributeValueNamed:'emissiveColor').
	shininess _ (node attributeValueNamed: 'shininess').
	specularColor _ (node attributeValueNamed: 'specularColor').
	transparency _ (node attributeValueNamed:'transparency').
	material _ TMaterial new.
	material ambientColor: (diffuseColor * ambientIntensity).
	material diffuseColor: diffuseColor.
	material specularColor: specularColor.
	material emissiveColor: emissiveColor.
	material shininess: shininess.
	material transparency: transparency.
	attributes at: #currentMaterial put: material.! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 21:20'!
doNamedNode: node
	| lastName |
	progress value:'Creating ', node name,' ...'.
	lastName _ attributes at: #currentName ifAbsent:[nil].
	attributes at: #currentName put: node name.
	super doNamedNode: node.
	lastName
		ifNil:[attributes removeKey: #currentName]
		ifNotNil:[attributes at: #currentName put: lastName].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doNormal: node
	| attr points |
	(attr _ node attributeValueNamed: 'vector') notNil
		ifTrue:[points _ self mfVec3fFrom: attr].
	points == nil
		ifTrue:[attributes removeKey: #currentNormals]
		ifFalse:[attributes at: #currentNormals put: points].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/29/2004 19:55'!
doShape: node
	| attr shape |
	attributes at: #currentTexture put: nil.
	attributes at: #currentMaterial put: nil.
	attributes at: #currentShape put: nil.
	(attr _ node attributeValueNamed: 'appearance') notNil
		ifTrue:[attr doWith: self].
	(attr _ node attributeValueNamed: 'geometry') notNil
		ifTrue:[attr doWith: self].
	shape _ attributes at: #currentShape.
	shape == nil ifFalse:[
		shape material: (attributes at: #currentMaterial ifAbsent:[nil]).
		"shape setTexturePointer: (attributes at: #currentTexture ifAbsent:[nil])" ].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 08:16'!
doSphere: node
	| radius sphere |
	radius _ (node attributeValueNamed:'radius').
	sphere _ B3DIndexedMesh vrml97Sphere.
	self createFrameFor: sphere defaultName:'sphere'.
	currentFrame resizeRightNow: radius @ radius @ radius undoable: false.
! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doSwitch: node
	| choices which |
	choices _ (node attributeValueNamed:'choices').
	which _ (node attributeValueNamed: 'whichChoice') + 1.
	(which > 0 and:[which <= choices size])
		ifTrue:[(choices at: which) doWith: self].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 09:00'!
doTextureCoordinate: node

	| attr points |
	(attr _ node attributeValueNamed: 'point') notNil
		ifTrue:[points _ self mfVec2fFrom: attr].
	points == nil
		ifTrue:[attributes removeKey: #currentTexCoords]
		ifFalse:[attributes at: #currentTexCoords put: points].! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/27/2004 10:14'!
doTransform: node
	| attr c r s sr t xform oldFrame |
	attr _ node attributeValueNamed: 'center'.
	attr notNil ifTrue:[c _ self positionFrom: attr].
	attr _ node attributeValueNamed: 'rotation'.
	attr notNil ifTrue:[r _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'scale'.
	attr notNil ifTrue:[s _ self scaleFrom: attr].
	attr _ node attributeValueNamed: 'scaleOrientation'.
	attr notNil ifTrue:[sr _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'translation'.
	attr notNil ifTrue:[t _ self positionFrom: attr].
	xform _ B3DMatrix4x4 identity.
	xform translation: t+c.
	xform _ xform composedWithLocal: r asMatrix4x4.
	xform _ xform composedWithLocal: sr asMatrix4x4.
	xform _ xform composedWithLocal: (B3DMatrix4x4 identity scaling: s).
	xform _ xform composedWithLocal: sr negated asMatrix4x4.
	xform _ xform composedWithLocal: (B3DMatrix4x4 identity translation: c negated).
	oldFrame _ currentFrame.
	currentFrame _ self createFrameFor: nil.
	currentFrame setComposite: xform.
	super doTransform: node.
	currentFrame _ oldFrame.! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 22:30'!
doViewpoint: node
	| attr pos r fov name m camera |

	attr _ node attributeValueNamed: 'position'.
	attr notNil ifTrue:[pos _ self positionFrom: attr].
	attr _ node attributeValueNamed: 'orientation'.
	attr notNil ifTrue:[r _ self rotationFrom: attr].
	attr _ node attributeValueNamed: 'fieldOfView'.
	attr notNil ifTrue:[fov _ attr radiansToDegrees].
	attr _ node attributeValueNamed: 'description'.
	attr notNil ifTrue:[name _ attr].
	m _ B3DMatrix4x4 identity.
	m _ m composedWithGlobal: (r asMatrix4x4).
	m _ m composedWithGlobal: (B3DMatrix4x4 withOffset: pos).
	defaultCamera _ TeapotMorph current activeCamera.
	defaultCamera viewAngle: m.

"
	(currentFrame == baseFrame and:[defaultCamera ~~ nil]) ifTrue:[
		camera _ defaultCamera.
		defaultCamera _ nil.
	] ifFalse:[
		camera _ TCamera new initializeWithViewPort: (TeapotMorph current).
		currentFrame addChild: camera.
	].
	camera viewAngle: m.
	camera setFieldOfView: fov."! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/28/2004 19:39'!
facesFrom: anArray for: vertices
	"Create and return a set of faces from the given index array"
	| faces vtx |
	vtx _ WriteStream on: (Array new: 4).
	faces _ WriteStream on: (Array new: anArray size // 4).
	anArray do:[:idx|
		idx = -1 ifTrue:[
			vtx position > 2 
				ifTrue:[faces nextPut: (B3DSimpleMeshFace withAll: vtx contents)].
			vtx reset.
		] ifFalse:[
			vtx nextPut: (B3DSimpleMeshVertex new position: (vertices at: idx+1)).
		].
	].
	^faces contents! !

!VRMLCroquetBuilder methodsFor: 'enumerating nodes' stamp: 'daf 11/29/2004 19:55'!
initializeFor: aTSpace
	| |
	myTSpace _ aTSpace.
	defaultCamera _ TeapotMorph current activeCamera.
	defaultMaterial _ TMaterial new initialize.
! !

!VRMLCroquetBuilder methodsFor: 'initialize' stamp: 'daf 11/27/2004 09:00'!
on: aVRMLScene
	scene _ aVRMLScene! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
mfVec2fFrom: anArray
	"Convert the given array into a B3DVector2Array"
	| pts |
	pts _ WriteStream on: (B3DTexture2Array new: anArray size).
	anArray do:[:spec|
		pts nextPut: (B3DVector2 u: (spec at: 1) v: (spec at: 2)).
	].
	^pts contents! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
mfVec3fFrom: anArray
	"Convert the given array into a B3DVector3Array"
	| pts |
	pts _ WriteStream on: (B3DVector3Array new: anArray size).
	anArray do:[:spec|
		pts nextPut: (B3DVector3 x: (spec at: 1) y: (spec at: 2) z: 0.0 - (spec at: 3)).
	].
	^pts contents! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
mfVec3fFromInterpolator: node
	| key value len values vv keySize |
	key _ node attributeValueNamed: 'key'.
	value _ node attributeValueNamed: 'keyValue'.
	keySize _ key size.
	values _ Array new: keySize.
	len _ value size // keySize.
	1 to: values size do:[:i|
		vv _ B3DVector3Array new: len.
		vv replaceFrom: 1 to: len with: value startingAt: (i-1 * len)+1.
		values at: i put: (self mfVec3fFrom: vv).
	].
	^values! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
positionFrom: attr
	"Fix up coord systems"
	^B3DVector3 x: (attr at: 1) y: (attr at: 2) z: 0.0 - (attr at: 3).
! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
rotationFrom: attr
	"Fix up coord systems.
	FIXME: attr should always be a B3DRotation but for now
	the defaults are arrays. How ugly..."
	attr class == Array
		ifTrue:[^B3DRotation radiansAngle: (attr at: 4) negated axis: 
			(B3DVector3 x: (attr at: 1) y: (attr at: 2) z: (attr at: 3))]
		ifFalse:[^attr negated]! !

!VRMLCroquetBuilder methodsFor: 'converting' stamp: 'daf 11/27/2004 09:00'!
scaleFrom: attr
	"Fix up coord systems"
	^B3DVector3 x: (attr at: 1) y: (attr at: 2) z: (attr at: 3).
! !


!VRMLCroquetBuilder class methodsFor: 'instance creation' stamp: 'daf 11/27/2004 09:00'!
on: aVRMLScene
	^self new on: aVRMLScene! !


!VRMLCroquetBuilder reorganize!
('building frames' baseFrame baseFrame: buildFrames buildFramesFor: createFrameFor: createFrameFor:defaultName: createFrameFor:name:suffix: createFrameFor:suffix: createSimpleFrame:named:parent: currentFrame currentFrame: doConvert: makeFrameNamed:)
('enumerating nodes' assignIndexedColors:in: assignIndexedNormals:in: assignIndexedTexCoords:in: doAppearance: doBox: doColor: doCone: doCoordinate: doCylinder: doDirectionalLight: doImageTexture: doIndexedFaceSet: doLOD: doMaterial: doNamedNode: doNormal: doShape: doSphere: doSwitch: doTextureCoordinate: doTransform: doViewpoint: facesFrom:for: initializeFor:)
('enumerating')
('initialize' on:)
('converting' mfVec2fFrom: mfVec3fFrom: mfVec3fFromInterpolator: positionFrom: rotationFrom: scaleFrom:)
!

